from splverifier.api.base import Record
import os
import splverifier

SPLVERIFIER_DIR = os.path.abspath(os.path.dirname(splverifier.__file__)) + '/'
EXTERNAL_DIR = SPLVERIFIER_DIR + 'external/'
TESTING = EXTERNAL_DIR + 'test/'

PATHS = Record(
    base = SPLVERIFIER_DIR,
    output = SPLVERIFIER_DIR + 'output/',
    featurehouse_jar = EXTERNAL_DIR + 'FeatureHouse.jar',
    autofeature = Record(
        introduction_dir = EXTERNAL_DIR + 'dependencies',
        tmpdir = TESTING + 'autofeature_tmp',
        autofeature_jar = EXTERNAL_DIR + 'autoFeature.jar',
        acc_bin = EXTERNAL_DIR + 'ACC/bin/acc',
    ),
    cpachecker = Record(
        cpachecker_dir = '/path/to/cpachecker',
        ulimit_v = '6291456',
        timeout = 60 * 60 * 60,
    ),
    cil = Record(
        tmpdir = TESTING + 'cil_tmp',
        cilly_bin = '/path/to/cilly',
    ),
    testing = Record(
        containment_hierarchy = TESTING + 'data/testspl/features',
        variant = TESTING + 'data/testspl/variant1.exp',
        modelcnf = TESTING + 'data/testspl/model.cnf',
        tmpdir = TESTING + 'tmp',
    ),
)
