#from splverifier.api.base import Error

class ModelChecker(object):
    """
    Modelchecker abstraction
    
    implementations need to provide a method do check:
    
    def do_check(checkable) -> CheckResult
    
    checkable is the output of the weaver
    """
    
    def check(self, variant):
        if not variant.checkable:
            raise Error("Given variant is not checkable")
        return self.do_check(variant)

