from splverifier.api import modelchecker
from splverifier.api.fs import *
from splverifier.api.config import *
from splverifier.api.statistics import format_time
from datetime import timedelta

class CBMC(modelchecker.ModelChecker):

    statsfile = '/home/henne/splvs.log'
    logfile = PATHS.cpachecker.cpachecker_dir + '/test/output/full_log.txt'
    
    
    def __init__(self):
        modelchecker.ModelChecker.__init__(self)
    
    def do_check(self, variant):
        #resultfs = FileStore(variant.location, 'result_CPAchecker').create()
        #if not hasattr(variant, 'cilfile'):
        #    self.transform_to_cil(variant)
        variant.check_result, variant.check_time = self.check_files(
            variant.checkable,
            '',
            excludes = ['wsllib.c']
        )
        variant.preparation_time = timedelta(0)
        return variant


    def check_files(self, sourcedir, outdir, excludes=None):
        files = [f for f in os.listdir(sourcedir) if f.endswith('.c') and f not in excludes]
        logfile = sourcedir + '/cbmc_full.log'
        timer = Timer().start()
        try:
            wait_timeout(
                'cd %s;ulimit -v %s;cbmc --error-label error\
                     %s 2>&1 | tee %s' % (
                        sourcedir,
                        PATHS.cpachecker.ulimit_v,
                        ' '.join(files),
                        logfile,
                     ),
                PATHS.cpachecker.timeout
            )
        except RuntimeError:
            system('killall cbmc')
        
        timer.stop()
        
        fp = open(self.statsfile, 'a')
        fp.write('%s\t%s\n' %(sourcedir, format_time(timer.elapsed)))
        fp.close()
        
        time.sleep(1)
        result = self.extract_result(logfile)
        
        #system('cd %s;mv test/output %s' % (PATHS.cpachecker.cpachecker_dir, outdir))
        #system('cd %s;mkdir -p test/output' % (PATHS.cpachecker.cpachecker_dir,))
        return (result, timer.elapsed)
        
    def extract_result(self, logfile):
        contents = open(logfile).read()
        
        if 'VERIFICATION FAILED' in contents:
            return 'BUG'
            
        elif 'VERIFICATION SUCCESSFUL' in contents:
            return 'SAFE'
        
        else:
            return 'OOM'
